;=========================================================================
;
; Liaisons d'attributs V6.50
;
; (C) Patrick_35
;
;=========================================================================

;-------------------------------------------------------------------------
; Racteur pour mettre  jour le texte de l'attribut
;-------------------------------------------------------------------------

(defun patrick:modifier_attribut(obj rea arg / i j modif n r s val1 val2)
  (if (< modification_attribut_en_cours 3)
    (progn
      (if (and (eq obj (car (vlr-owners rea))) (eq modification_attribut_en_cours 0))
	(setq prendre_avant_dernier T)
      )
      (if (vlax-read-enabled-p obj)
	(cond
	  ((and (< modification_attribut_en_cours 1)
		(eq (vlr-data rea) "Croissant")
		(not (eq obj (car (reverse (vlr-owners rea))))))
	    (princ "\nVeuillez slectionner le premier Attribut de la chane croissante.")
	    (setq modification_attribut_en_cours 2)
	  )
	  ((and (< modification_attribut_en_cours 1)
		(eq (vlr-data rea) "Somme")
		(eq obj (car (reverse (vlr-owners rea)))))
	    (princ "\nVeuillez ne pas slectionner le premier Attribut de la chane somme.")
	    (setq modification_attribut_en_cours 2)
	  )
	  ((eq modification_attribut_en_cours 0)
	    (setq r (rechercher_data obj) modification_attribut_en_cours 1)
	    (setq r (append (list (car r) (cadr r) (vla-get-textstring obj)) (member (cadddr r) r)) n 3)
	    (vlax-ldata-put "Patrick_35" (car r) (cdr r))
	    (while (setq j (nth n r))
	      (if (vlax-read-enabled-p j)
		(cond
		  ((eq (cadr r) "Identique")
		    (vl-catch-all-apply 'vla-put-textstring (list j (caddr r)))
		  )
		  ((eq (cadr r) "Croissant")
		    (if (eq n 3)
		      (vl-catch-all-apply 'vla-put-textstring (list j (caddr r)))
		      (vl-catch-all-apply 'vla-put-textstring (list j (incsuff (vla-get-textstring (nth (1- n) r)) 1 T)))
		    )
		  )
		  ((eq (cadr r) "Somme")
		    (if (eq n 3)
		      (setq val1 0 val2 0)
		      (setq val1 (read (vla-get-textstring (cadddr r))) val2 (read (vla-get-textstring j)))
		    )
		    (ecrire_texte_somme val1 val2 (cadddr r))
		  )
		)
		(effacer_data j)
	      )
	      (setq n (1+ n))
	    )
	  )
	)
	(effacer_data obj)
      )
      (if prendre_avant_dernier
	(if (eq obj (cadr (vlr-owners rea)))
	  (setq modification_attribut_en_cours 0 prendre_avant_dernier nil)
	)
	(if (eq obj (car (vlr-owners rea)))
	  (setq modification_attribut_en_cours 0)
	)
      )
    )
  )
)

;-------------------------------------------------------------------------
; Refaire les racteurs en fonction de la base "Patrick_35"
;-------------------------------------------------------------------------

(defun refaire_les_reacteurs_objet(/ n r)
  (setq modification_attribut_en_cours 0)
  (if (vlax-ldata-list "Patrick_35")
    (progn
      (foreach n (vlax-ldata-list "Patrick_35")
	(if (nth 4 n)
	  (vlr-object-reactor (member (cadddr n) n) (cadr n) (list (cons :vlr-Modified (function patrick:modifier_attribut))))
	  (setq r (cadddr n))
	)
      )
      (if r
	(effacer_data r)
      )
    )
  )
)

;-------------------------------------------------------------------------
; Ajouter/supprimer un objet dans les racteurs objets
;-------------------------------------------------------------------------

(defun ajouter_suppr_obj_reacteur(base data ajout / lst n rea)
  (if (setq rea (vlr-reactors :vlr-object-reactor))
    (progn
      (setq n 1)
      (while (nth n rea)
	(if (member base (vlr-owners (nth n rea)))
	  (setq lst (nth n rea))
	)
	(setq n (1+ n))
      )
      (if lst
	(progn
	  (if ajout
	    (vlr-owner-add lst data)
	    (vlr-owner-remove lst data)
	  )
	  (if (eq (length (vlr-owners lst)) 1)
	    (vlr-remove lst)
	  )
	)
      )
    )
  )
)

;-------------------------------------------------------------------------
; Supprimer les racteurs objet
;-------------------------------------------------------------------------

(defun effacer_les_reacteurs_objet(/ liaison n rea)
  (setq modification_attribut_en_cours 3)
  (if (setq rea (vlr-reactors :vlr-object-reactor))
    (progn
      (setq n 1 rea (nth n (car rea)))
      (while rea
	(setq liaison nil)
	(if (eq (cdr (car (vlr-reactions rea))) 'PATRICK:MODIFIER_ATTRIBUT)
	  (setq liaison rea)
	)
	(if liaison
	  (vlr-remove rea)
	  (setq n (1+ n))
	)
	(if (setq rea (vlr-reactors :vlr-object-reactor))
	  (setq rea (nth n (car rea)))
	)
      )
    )
  )
)

;-------------------------------------------------------------------------
; Racteurs pour pointer avant la commande copier
;-------------------------------------------------------------------------

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Sur le racteur editor
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

(defun debut_command_attr(rea cde)
  (setq modification_attribut_en_cours 0 modification_command_undo T)
  (cond
    ((or (eq (car cde) "UNDO")(eq (car cde) "U"))
      (setq modification_attribut_en_cours 3)
      (effacer_les_reacteurs_objet)
    )
    ((member (car cde) (list "MOVE"      "MIRROR"      "SCALE"      "ROTATE"      "STRETCH"
			"GRIP_MOVE" "GRIP_MIRROR" "GRIP_SCALE" "GRIP_ROTATE" "GRIP_STRETCH"))
      (setq modification_attribut_en_cours 3)
    )
  )
)


;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Sur le racteur deepclone
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

(defun debut_command_copier(rea cde)
  (setq derniere_entite (entlast) modification_attribut_en_cours 0)
)

;-------------------------------------------------------------------------
; Racteur pour supprimer la surbrillance de la copie
;-------------------------------------------------------------------------

(defun arret_command_copier(rea cde / js n)
  (if (setq js (ssget "_p"))
    (progn
      (setq n 0)
      (while (ssname js n)
	(redraw (ssname js n) 4)
	(setq n (1+ n))
      )
    )
  )
  (setq modification_attribut_en_cours 0)
)

;-------------------------------------------------------------------------
; Racteur que la copie s'est bien passe
;-------------------------------------------------------------------------

(defun fin_command_copier (rea cde / ent1 ent2 j js1 js2 js3 n tot1 tot2 val1 val2)
  (if (setq js3 (ssget "_p"))
    (progn
      (setq n 0 js2 (ssadd))
      (while (ssname js3 n)
	(if (eq (cdr (assoc 0 (entget (ssname js3 n)))) "INSERT")
	  (if (cdr (assoc 66 (entget (ssname js3 n))))
	    (ssadd (ssname js3 n) js2)
	  )
	)
	(setq n (1+ n))
      )
      (setq js1 (ssadd) n (entnext derniere_entite))
      (while n
	(if (eq (cdr (assoc 0 (entget n))) "INSERT")
	  (if (cdr (assoc 66 (entget n)))
	    (ssadd n js1)
	  )
	)
	(setq n (entnext n))
      )
      (setq j 0 js3 (ssadd))
      (while (ssname js1 j)
	(setq n 0)
	(while (ssname js2 n)
	  (if (eq (cdr (assoc 2 (entget (ssname js1 j)))) (cdr (assoc 2 (entget (ssname js2 n)))))
	    (progn
	      (ssadd (ssname js2 n) js3)
	      (ssdel (ssname js2 n) js2)
	      (setq n (sslength js2))
	    )
	  )
	  (setq n (1+ n))
	)
	(setq j (1+ j))
      )
      (setq n 0 js2 js3)
      (if (not (zerop (sslength js1)))
	(while (setq ent1 (ssname js2 n))
	  (setq tot1 0)
	  (while (not (eq (cdr (assoc 0 (entget ent1))) "SEQEND"))
	    (setq ent1 (entnext ent1))
	    (if (eq (cdr (assoc 0 (entget ent1))) "ATTRIB")
	      (if (setq r (rechercher_data (vlax-ename->vla-object ent1)))
		(progn
		  (setq ent2 (entnext (ssname js1 n)) tot2 0)
		  (while (< tot2 tot1)
		    (setq ent2 (entnext ent2) tot2 (1+ tot2))
		  )
		  (setq j (append (cdr r) (list (vlax-ename->vla-object ent2))))
		  (effacer_les_reacteurs_objet)
		  (cond
		    ((= (car j) "Croissant")
		      (vla-put-textstring (nth (1- (length j)) j) (incsuff (vla-get-textstring (nth (- (length j) 2) j)) 1 T))
		    )
		    ((= (car j) "Somme")
		      (setq val1 (read (vla-get-textstring (caddr j))) val2 (read (vla-get-textstring (nth (1- (length j)) j))))
		      (ecrire_texte_somme val1 val2 (caddr j))
		    )
		  )
		  (vlax-ldata-put "Patrick_35" (car r) j)
		  (refaire_les_reacteurs_objet)
		)
	      )
	    )
	    (setq tot1 (1+ tot1))
	  )
	  (setq n (1+ n))
	)
      )
    )
  )
)

;-------------------------------------------------------------------------
; Racteur que la commande s'est bien passe
;-------------------------------------------------------------------------

(defun fin_d_un_command(rea cde / data e i j n val1 val2)
  (cond
    ((or (eq (car cde) "UNDO")
	 (eq (car cde) "U"))
      (if modification_command_undo
	(progn
	  (refaire_les_reacteurs_objet)
	  (setq modification_command_undo nil)
	)
      )
    )
    ((or (eq (car cde) "ERASE")
	 (eq (car cde) "EXPLODE"))
      (if (vlax-ldata-list "Patrick_35")
	(foreach n (vlax-ldata-list "Patrick_35")
	  (setq j 3)
	  (while (setq data (nth j n))

	    (if (vl-catch-all-error-p (vl-catch-all-apply 'vla-objectidtoobject (list (vla-get-database data) (vla-get-ownerid data))))
	      (progn
		(effacer_data data)
		(setq e T)
	      )
	    )
	    (setq j (1+ j))
	 )
	)
      )
      (if (and e (vlax-ldata-list "Patrick_35"))
	(progn
	  (effacer_les_reacteurs_objet)
	  (foreach n (vlax-ldata-list "Patrick_35")
	    (cond
	      ((eq (cadr n) "Croissant")
		(setq j 3 i (caddr n))
		(while (setq data (nth j n))
		  (if (vlax-read-enabled-p data)
		    (progn
		      (vla-put-textstring data i)
		      (setq i (incsuff i 1 T))
		    )
		  )
		  (setq j (1+ j))
		)
	      )
	      ((eq (cadr n) "Somme")
		(setq j 3)
		(while (setq data (nth j n))
		  (if (vlax-read-enabled-p data)
		    (progn
		      (if (eq j 3)
			(setq val1 0 val2 0)
			(setq val1 (read (vla-get-textstring (cadddr n))) val2 (read (vla-get-textstring (nth j n))))
		      )
		    (ecrire_texte_somme val1 val2 (cadddr n))
		    )
		  )
		  (setq j (1+ j))
		)
	      )
	    )
	  )
	  (refaire_les_reacteurs_objet)
	)
      )
    )
    (T
      (arret_command_copier rea cde)
    )
  )
)

;-------------------------------------------------------------------------
; Supprimer les racteurs command
;-------------------------------------------------------------------------

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Sur les racteurs deepclone
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

(defun effacer_les_reacteurs_deepclone(/ i j k l n)
  (if (setq i (vlr-reactors :vlr-deepclone-reactor))
    (progn
      (setq n 1 i (nth n (car i)) l 0)
      (while i
	(setq j nil)
	(if (or (eq (cdr (nth l (vlr-reactions i))) 'DEBUT_COMMAND_COPIER)
		(eq (cdr (nth l (vlr-reactions i))) 'ARRET_COMMAND_COPIER)
		(eq (cdr (nth l (vlr-reactions i))) 'FIN_COMMAND_COPIER))
	  (setq j i)
	  (setq l (1+ l))
	)
	(if j
	  (progn
	    (setq k (vl-remove (nth l (vlr-reactions i)) (vlr-reactions i)))
	    (vlr-remove j)
	    (if k
	      (vlr-deepclone-reactor nil k)
	    )
	  )
	  (if (not (nth l (vlr-reactions i)))
	    (setq n (1+ n) l 0)
	  )
	)
	(if (setq i (vlr-reactors :vlr-deepclone-reactor))
	  (setq i (nth n (car i)))
	)
      )
    )
  )
)

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Sur les racteurs editor
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

(defun effacer_les_reacteurs_editor(/ i j k l n)
  (if (setq i (vlr-reactors :vlr-editor-reactor))
    (progn
      (setq n 1 i (nth n (car i)) l 0)
      (while i
	(setq j nil)
	(if (or (eq (cdr (nth l (vlr-reactions i))) 'DEBUT_COMMAND_ATTR)
		(eq (cdr (nth l (vlr-reactions i))) 'FIN_D_UN_COMMAND)
		(eq (cdr (nth l (vlr-reactions i))) 'ARRET_COMMAND_COPIER)
		(eq (cdr (nth l (vlr-reactions i))) 'EFFACER_DES_REACTEURS))
	  (setq j i)
	  (setq l (1+ l))
	)
	(if j
	  (progn
	    (setq k (vl-remove (nth l (vlr-reactions i)) (vlr-reactions i)))
	    (vlr-remove j)
	    (if k
	      (vlr-editor-reactor nil k)
	    )
	  )
	  (if (not (nth l (vlr-reactions i)))
	    (setq n (1+ n) l 0)
	  )
	)
	(if (setq i (vlr-reactors :vlr-editor-reactor))
	  (setq i (nth n (car i)))
	)
      )
    )
  )
)

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Sur les racteurs editor&deepclone
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

(defun effacer_les_reacteurs_command()
  (effacer_les_reacteurs_deepclone)
  (effacer_les_reacteurs_editor)
)

;-------------------------------------------------------------------------
; Rechercher un attribut dans la base "Patrick_35"
;-------------------------------------------------------------------------

(defun rechercher_data(data / n r)
  (foreach n (vlax-ldata-list "Patrick_35")
    (if (member data (cdr n))
      (setq r n)
    )
  )
  r
)

;-------------------------------------------------------------------------
; Effacer un attribut de la base "Patrick_35"
;-------------------------------------------------------------------------

(defun effacer_data(sel_att / i n r)
  (if (setq r (rechercher_data sel_att))
    (progn
      (ajouter_suppr_obj_reacteur (cadddr r) sel_att nil)
      (setq n (vl-remove sel_att (cdr r)))
      (if (or (eq (length n) 3) (not n))
	(progn
	  (vlax-ldata-delete "Patrick_35" (car r))
	  (if (vlax-ldata-list "Patrick_35")
	    (progn
	      (setq n 0)
	      (while (setq i (nth n (reverse (vlax-ldata-list "Patrick_35"))))
		(if (not (eq (itoa n) (car i)))
		  (vlax-ldata-put "Patrick_35" (itoa n) (cdr i))
		)
		(setq n (1+ n))
	      )
	      (vlax-ldata-delete "Patrick_35" (itoa (1- n)))
	    )
	  )
	)
	(vlax-ldata-put "Patrick_35" (car r) n)
      )
    )
  )
  r
)


;-------------------------------------------------------------------------
; Ecrire un texte dans la chane somme
;-------------------------------------------------------------------------

(defun ecrire_texte_somme(val1 val2 obj / sv_zp)
  (setq sv_zp (getvar "dimzin"))
  (setvar "dimzin" 4)
  (if (and (not (eq (type val1) 'INT))(not (eq (type val1) 'REAL)))
    (setq val1 0)
  )
  (if (and (not (eq (type val2) 'INT))(not (eq (type val2) 'REAL)))
    (setq val2 0)
  )
  (if (or (eq (type val1) 'REAL) (eq (type val2) 'REAL))
    (vl-catch-all-apply 'vla-put-textstring (list obj (rtos (+ val1 val2))))
    (vl-catch-all-apply 'vla-put-textstring (list obj (itoa (+ val1 val2))))
  )
  (setvar "dimzin" sv_zp)
)


;-------------------------------------------------------------------------
; Slectionner une chane d'attributs
;-------------------------------------------------------------------------

(defun selection_chaine(/ n sel_att)
  (if (vlax-ldata-list "Patrick_35")
    (while (not sel_att)
      (setq sel_att (car (nentsel (strcat"\nSlection d'une chane d'attributs : "))))
      (if sel_att
	(if (eq (cdr (assoc 0 (entget sel_att))) "ATTRIB")
	  (if (not (setq n (rechercher_data (vlax-ename->vla-object sel_att))))
	    (progn
	      (princ "\nAttribut non associ.")
	      (setq sel_att nil)
	    )
	  )
	  (progn
	    (princ "\nCe n'est pas un Attribut.")
	    (setq sel_att nil)
	  )
	)
      )
    )
    (princ "\nPas encore d'association d'attributs.")
  )
  n
)

;-------------------------------------------------------------------------
; Incrementer la valeur de +1
;-------------------------------------------------------------------------

;; INCSUFF - Gilles Chanteau - 15/01/08
;; Incrmente le suffixe d'une chane de caractres de la valeur spcifie.
;; Est pris en compte comme suffixe, l'ensemble des caractres [0-9] depuis
;; la fin de la chane ainsi que les caractres [A-Z] et [a-z] si alpha est non nil
;;
;; Arguments
;; str : une chane avec un suffixe valide
;; inc : un entier positif
;; alpha : si non nil, les caractres [a-z] [A-Z] sont intgrs au suffixe
;;
;; Retour
;; la chane avec son suffixe incrment (ou nil si aucun suffixe valide)
;;
;; Exemples :
;; (incsuff "N002" 12 T) = "N014"
;; (incsuff "test_ZZ9" 1 T) = "test_AAA0"
;; (incsuff "test_ZZ9" 1 nil) = "test_ZZ10"
;; (incsuff "12-" 1 nil) = nil

(defun incsuff (str inc alpha / lst crt pas ind dep quo ret)
  (setq lst (reverse (vl-string->list str)))
  (while
    (and
      (setq crt (car lst))
      (cond
	((< 47 crt 58)
	  (setq pas 10
		ind 48
	  )
	)
	((and alpha (< 64 crt 91))
	  (setq pas 26
		ind 65
	  )
	)
	((and alpha (< 96 crt 123))
	  (setq pas 26
		ind 97
	  )
	)
	((< 0 quo)
	  (setq crt (if (= 10 pas)
		      ind
		      (1- ind)
		    )
		lst (cons (car lst) lst)
	  )
	)
      )
    )
    (setq dep (- crt ind)
	  quo (/ (+ dep inc) pas)
	  ret (cons (+ ind (rem (+ dep inc) pas)) ret)
    )
    (if (zerop quo)
      (setq ret (append (reverse (cdr lst)) ret)
	    lst nil
      )
      (if (cdr lst)
	(setq lst (cdr lst)
	      inc quo
	)
	(setq lst (list ind)
	      inc (if (= 10 pas)
		    quo
		    (1- quo)
		  )
	)
      )
    )
  )
  (if ret
    (vl-list->string ret)
  )
)

;-------------------------------------------------------------------------
; Visualiser  l'aide d'une polyligne une chane de liaison
;-------------------------------------------------------------------------

(defun c:vatt(/ a b i n lst)
  (vla-startundomark (vla-get-activedocument (vlax-get-acad-object)))
  (if (setq n (selection_chaine))
    (progn
      (foreach i (member (cadddr n) n)
	(setq a (tblsearch "layer" (vla-get-layer (vla-objectidtoobject (vla-get-database i)(vla-get-ownerid i))))
	      b (tblsearch "layer" (vla-get-layer i)))
	(if (and (not (eq (logand (cdr (assoc 70 a)) 1) 1))
		 (not (eq (logand (cdr (assoc 70 b)) 1) 1))
		 (not (< (cdr (assoc 62 a)) 0))
		 (not (< (cdr (assoc 62 b)) 0)))
	  (setq lst (append lst (list (cons 10 (trans (vlax-safearray->list (vlax-variant-value (vla-get-insertionpoint i)))(vlax-vla-object->ename i) 1)))))
	)
      )
      (setq lst (append (list (cons 0 "LWPOLYLINE")
			      (cons 100 "AcDbEntity")
			      (cons 100 "AcDbPolyline")
			      (cons 90 (1- (length n))))
			lst))
      (entmake lst)
    )
  )
  (vla-endundomark (vla-get-activedocument (vlax-get-acad-object)))
  (princ)
)

;-------------------------------------------------------------------------
; Effacer une chane de liaison d'attributs
;-------------------------------------------------------------------------

(defun c:eatt(/ i n nu olderr rep err)

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Gestion des erreure
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  (defun err (msg / i n)
    (if (/= msg "Fonction annule") 
      (princ (strcat "\nErreur : " msg))
      (princ msg)
    )
    (foreach i (member (cadddr nu) nu)
      (redraw (vlax-vla-object->ename i) 4)
    )
    (setq *error* olderr)
    (vla-endundomark (vla-get-activedocument (vlax-get-acad-object)))
    (princ)
  )

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Routine principale
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  (vla-startundomark (vla-get-activedocument (vlax-get-acad-object)))
  (setq olderr *error* *error* err)
  (if (setq nu (selection_chaine))
    (progn
      (foreach i (member (cadddr nu) nu)
	(redraw (vlax-vla-object->ename i) 3)
      )
      (initget "Oui Non")
      (setq rep (getkword "\nDsirez-vous supprimer cette chane de liaison d'attributs (Oui/Non) <N> : "))
      (if (not rep)
	(setq rep "Non")
      )
      (foreach i (member (cadddr nu) nu)
	(redraw (vlax-vla-object->ename i) 4)
      )
      (if (eq rep "Oui")
	(progn
	  (effacer_les_reacteurs_objet)
	  (vlax-ldata-delete "Patrick_35" (car nu))
	  (if (vlax-ldata-list "Patrick_35")
	    (if (nth (atoi (car nu)) (reverse (vlax-ldata-list "Patrick_35")))
	      (progn
		(setq n 0)
		(while (setq i (nth n (reverse (vlax-ldata-list "Patrick_35"))))
		  (if (not (eq (itoa n) (car i)))
		    (vlax-ldata-put "Patrick_35" (itoa n) (cdr i))
		  )
		  (setq n (1+ n))
		)
		(vlax-ldata-delete "Patrick_35" (itoa (1- n)))
	      )
	    )
	  )
	  (princ "\nChane d'attributs efface.")
	  (refaire_les_reacteurs_objet)
	)
	(princ "\nAbandon.")
      )
    )
  )
  (setq *error* olderr)
  (vla-endundomark (vla-get-activedocument (vlax-get-acad-object)))
  (princ)
)

;-------------------------------------------------------------------------
; Conserver en mmoire une chaine afin de pouvoir faire des commandes Autocad
;-------------------------------------------------------------------------

(defun c:matt()
  (if (setq memoriser_attribut (nentsel "\nSlection de l'attribut/chane  mmoriser : "))
    (if (not (eq (cdr (assoc 0 (entget (car memoriser_attribut)))) "ATTRIB"))
      (progn
	(princ "\nCe n'est pas un attribut.")
	(setq memoriser_attribut nil)
      )
      (princ "\nAttribut/chane mmoris.")
    )
  )
  (princ)
)

;-------------------------------------------------------------------------
; crer une chane de liaison d'attributs
;-------------------------------------------------------------------------

(defun c:latt(/ att cont lst nu mode olderr r tot sel val1 val2 err selection_attribut)

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Gestion des erreurs
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  (defun err (msg / i n)
    (if (/= msg "Fonction annule")
      (princ (strcat "\nErreur : " msg))
      (princ msg)
    )
    (if att
      (redraw (vlax-vla-object->ename att) 4)
    )
    (if (vlax-ldata-get "Patrick_35" nu)
      (foreach i (member (caddr (vlax-ldata-get "Patrick_35" nu))(vlax-ldata-get "Patrick_35" nu))
	(redraw (vlax-vla-object->ename i) 4)
      )
    )
    (if (not cont)
      (while (> (length (vlax-ldata-get "Patrick_35" nu)) 2)
	(effacer_data (caddr (vlax-ldata-get "Patrick_35" nu)))
      )
    )
    (setq *error* olderr)
    (vla-endundomark (vla-get-activedocument (vlax-get-acad-object)))
    (princ)
  ) 

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Slectionner un attribut
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  (defun selection_attribut(msg / i j n sel_att txt)
    (if (eq msg "1")
      (setq msg (strcat msg "er"))
      (setq msg (strcat msg "em"))
    )
    (while (not sel_att)
      (initget 1 "Ajouter Retirer Quitter")
      (if (and (eq sel "Retirer") (eq msg "2em"))
	(setq sel "Ajouter")
      )
      (setq txt (strcat"\nSlection du " msg " attribut (Ajouter, Retirer, Quitter) "))
      (if (eq sel "Ajouter")
	(setq txt (strcat txt "<Ajouter> : "))
	(setq txt (strcat txt "<Retirer> : "))
      )
      (if memoriser_attribut
	(setq sel_att memoriser_attribut memoriser_attribut nil)
	(setq sel_att (nentsel txt))
      )
      (cond
	((eq sel_att "Ajouter")
	  (setq sel "Ajouter" sel_att nil)
	)
	((eq sel_att "Retirer")
	  (if (eq msg "1er")
	    (princ "\nVeuillez d'abord slectionner un attribut.")
	    (setq sel "Retirer")
	  )
	  (setq sel_att nil)
	)
	((not sel_att)
	  (setq sel_att "Quitter")
	)
      )
      (if sel_att
	(if (not (eq sel_att "Quitter"))
	  (if (= (cdr (assoc 0 (entget (car sel_att)))) "ATTRIB")
	    (progn
	      (setq sel_att (vlax-ename->vla-object (car sel_att)) r nil)
	      (foreach n (vlax-ldata-list "Patrick_35")
		(foreach i (member (cadddr n) n)
  		  (if (eq (vla-get-objectid i) (vla-get-objectid sel_att))
  		    (setq r T j n)
  		  )
		)
	      )
	      (if (and r (eq sel "Ajouter"))
		(progn
		  (if (eq msg "1er")
		    (progn
		      (foreach i (member (cadddr j) j)
			(redraw (vlax-vla-object->ename i) 3)
		      )
		      (setq tot (- (length j) 2) nu (car j) msg (strcat (itoa tot) "em") cont T)
		    )
		    (princ (strcat "\nAttribut de type " (cadr j) " dj associ."))
		  )
		  (setq sel_att nil)
		)
	      )
	      (if (and (not r) (eq sel "Retirer"))
		(progn
		  (princ "\nAttribut non associ.")
		  (setq sel_att nil)
		)
	      )
	    )
	    (progn
	      (princ "\nCe n'est pas un attribut.")
	      (setq sel_att nil)
	    )
	  )
	)
      )
    )
    sel_att
  )

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Routine principale
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  (vla-startundomark (vla-get-activedocument (vlax-get-acad-object)))
  (setq olderr *error* *error* err)
  (setq tot 1 mode "Identique")
  (if (not (vlax-ldata-list "Patrick_35"))
    (setq nu "0")
    (setq nu (itoa (length (vlax-ldata-list "Patrick_35"))))
  )
  (setq sel "Ajouter")
  (while (not (eq (setq att (selection_attribut (itoa tot))) "Quitter"))
    (if (eq sel "Ajouter")
      (progn
	(redraw (vlax-vla-object->ename att) 3)
	(if (eq tot 1)
	  (progn
	    (initget "Identique Croissant Somme")
	    (setq mode (getkword "\nType d'attributs Identique/Croissant/Somme <Identique> : "))
	    (if (not mode)
	      (setq mode "Identique")
	    )
	    (setq lst (list mode (vla-get-textstring att) att))
	  )
	  (setq lst (append (vlax-ldata-get "Patrick_35" nu) (list att)))
	)
	(setq tot (1+ tot))
      )
      (progn
	(redraw (vlax-vla-object->ename att) 4)
	(setq tot (1- tot) lst (vlax-ldata-get "Patrick_35" nu))
	(setq lst (vl-remove att lst))
      )
    )
    (vlax-ldata-put "Patrick_35" nu lst)
  )
  (if (not (eq tot 1))
    (progn
      (foreach r (member (caddr (vlax-ldata-get "Patrick_35" nu))(vlax-ldata-get "Patrick_35" nu))
	(redraw (vlax-vla-object->ename r) 4)
      )
      (if (eq tot 2)
	(progn
	  (princ "\nSlection que d'un seul attribut dans la chane.")
	  (vlax-ldata-delete "Patrick_35" nu)
	)
	(progn
	  (setq lst (vlax-ldata-get "Patrick_35" nu) n 3)
	  (while (nth n lst)
	    (cond
	      ((= (car lst) "Identique")
		(vla-put-textstring (nth n lst) (cadr lst))
	      )
	      ((= (car lst) "Croissant")
		(vla-put-textstring (nth n lst) (incsuff (vla-get-textstring (nth (1- n) lst)) 1 T))
	      )
	      ((= (car lst) "Somme")
		(if (eq n 3)
		  (setq val1 0)
		  (setq val1 (read (vla-get-textstring (caddr lst))))
		)
		(setq val2 (read (vla-get-textstring (nth n lst))))
		(ecrire_texte_somme val1 val2 (caddr lst))
	      )
	    )
	    (setq n (1+ n))
	  )
	  (if cont
	    (progn
	      (effacer_les_reacteurs_objet)
	      (refaire_les_reacteurs_objet)
	    )
	    (vlr-object-reactor (member (caddr lst) lst) (car lst) (list (cons :vlr-Modified (function patrick:modifier_attribut))))
	  )
	  (princ "\nChane de liaison traite.")
	)
      )
    )
  )
  (setq *error* olderr)
  (vla-endundomark (vla-get-activedocument (vlax-get-acad-object)))
  (princ)
)

;-------------------------------------------------------------------------
; Vrification que la base "Patrick_35" est correcte
;-------------------------------------------------------------------------

(defun verifier_base_Patrick_35(/ i n lst lst1 old r)
  (if (vlax-ldata-list "Patrick_35")
    (progn
      (foreach n (vlax-ldata-list "Patrick_35")
	(vlax-ldata-put "Patrick_35" (car n) (vl-remove nil (cdr n)))
	(if (eq (type (cadr n)) 'VLA-OBJECT)
	  (setq old T)
	)
      )
      (setq n 0 lst (vlax-ldata-list "Patrick_35"))
      (while (setq i (nth n lst))
	(if (or (and (not old) (nth 3 i) (nth 4 i)) (and old (nth 1 i) (nth 2 i)))
	  (setq lst1 (append lst1 (list (cdr i))))
	)
	(vlax-ldata-delete "Patrick_35" (car i))
	(setq n (1+ n))
      )
      (setq n 0)
      (while (setq i (nth n lst1))
	(vlax-ldata-put "Patrick_35" (itoa n) i)
	(setq n (1+ n))
      )
      (if (eq (type (cadr (vlax-ldata-get "Patrick_35" "0"))) 'VLA-OBJECT)
	(progn
	  (foreach n (vlax-ldata-list "Patrick_35")
	    (cond
	      ((eq (vla-get-textstring (cadr n))(vla-get-textstring (caddr n)))
		(setq i (append (list (car n) "Identique" (vla-get-textstring (cadr n))) (cdr n)))
	      )
	      ((eq (incsuff (vla-get-textstring (cadr n)) 1 T)(vla-get-textstring (caddr n)))
		(setq i (append (list (car n) "Croissant" (vla-get-textstring (cadr n))) (cdr n)))
	      )
	      (T
		(setq i (append (list (car n) "Somme" (vla-get-textstring (cadr n))) (cdr n)))
	      )
	    )
	    (vlax-ldata-put "Patrick_35" (car i) (cdr i))
	  )
	)
      )
    )
  )
)

;-------------------------------------------------------------------------
; Incrmenter des attributs
;-------------------------------------------------------------------------

(defun c:iatt(/ att n n_next sel olderr err)

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Gestion des erreurs
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  (defun err (msg / i n)
    (if (/= msg "Fonction annule")
      (princ (strcat "\nErreur : " msg))
      (princ msg)
    )
    (foreach att (member (cadddr sel) sel)
      (redraw (vlax-vla-object->ename att) 4)
    )
    (setq *error* olderr)
    (vla-endundomark (vla-get-activedocument (vlax-get-acad-object)))
    (princ)
  ) 

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Routine principale
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  (vla-startundomark (vla-get-activedocument (vlax-get-acad-object)))
  (setq olderr *error* *error* err)
  (if (setq sel (selection_chaine))
    (if (eq (cadr sel) "Croissant")
      (progn
	(foreach att (member (cadddr sel) sel)
	  (redraw (vlax-vla-object->ename att) 3)
	)
	(if (setq n_next (getstring "\nIncrementer en dbutant  [chiffre/lettre/alphanumrique]: "))
	  (progn
	    (effacer_les_reacteurs_objet)
	    (setq att (append (list (car sel) (cadr sel) n_next) (member (cadddr sel) sel)))
	    (vlax-ldata-put "Patrick_35" (car att) (cdr att))
	    (foreach att (member (cadddr sel) sel)
	      (vla-put-textstring att n_next)
	      (setq n_next (incsuff n_next 1 T))
	    )
	    (foreach att (member (cadddr sel) sel)
	      (redraw (vlax-vla-object->ename att) 4)
	    )
	    (refaire_les_reacteurs_objet)
	  )
	)
      )
      (princ (strcat "\nCette chane de liaison est du type " (cadr sel) ". Abandon."))
    )
  )
  (setq *error* olderr)
  (vla-endundomark (vla-get-activedocument (vlax-get-acad-object)))
  (princ)
)

;-------------------------------------------------------------------------
; Trier une chane d'attributs
;-------------------------------------------------------------------------

(defun c:tatt(/ att ch data dcl_id f i j n lst sel pos r val1 val2 dechex affiche deplace bas haut)

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; onvertir un chiffre numrique en hexa
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  (defun dechex (nb / r i)
    (setq r "")
    (while (and (= (type nb) 'INT) (> nb 0))
      (setq i (rem nb 16))
      (setq nb (lsh nb -4))
      (setq r (strcat (if (< i 10)
			(itoa i)
			(chr (+ 55 i ))
		      ) r))
    )
  )

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Affichage de la boite de dialogue
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  (defun affiche(dep / e n)
    (if dep
      (progn
	(start_list "att" 1)
	(foreach n sel
	  (add_list (vla-get-textstring n))
	)
	(end_list)
      )
    )
    (set_tile "pos" (itoa (1+ (atoi pos))))
    (setq e (nth (atoi pos) sel))
    (set_tile "bloc" (strcat "Nom du bloc : " (vla-get-name (vla-objectidtoobject (vla-get-database e)
							    (vla-get-ownerid e)))))
    (set_tile "etiq" (strcat "Etiquette : " (vla-get-tagstring e)))
    (set_tile "id" (strcat "ID de l'attribut : " (strcase (dechex (vla-get-objectid e)) T)))
    (if (eq pos "0")
      (mode_tile "haut" 1)
      (mode_tile "haut" 0)
    )
    (if (not (nth (1+ (atoi pos)) sel))
      (mode_tile "bas" 1)
      (mode_tile "bas" 0)
    )
    (if dep
      (set_tile "att" pos)
    )
  )

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Dplacer
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  (defun deplace (npos / n lst wsh)
    (setq Wsh (vlax-create-object "WScript.Shell"))
    (if (zerop (atoi npos))
      (vlax-invoke Wsh 'Popup "La valeur ne peut tre nulle" 0 "LATT" "48")
      (if (> (atoi npos) (length sel))
	(vlax-invoke Wsh 'Popup "La valeur saisie excde le nombre d'attributs de la chane" 0 "LATT" "48")
	(progn
	  (setq n 0 npos (1- (atoi npos)))
	  (while (< n npos)
	    (setq lst (append lst (list (nth n sel))))
	    (setq n (1+ n))
	  )
	  (setq lst (append lst (list (nth (atoi pos) sel))))
	  (while (nth n sel)
	    (if (not (eq n (atoi pos)))
	      (setq lst (append lst (list (nth n sel))))
	    )
	    (setq n (1+ n))
	  )
	  (setq sel lst pos (itoa npos))
	)
      )
    )
    (vlax-release-object Wsh)
  )

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Un coup vers le haut
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  (defun bas(/ n lst)
    (setq n 0)
    (while (nth n sel)
      (if (eq (atoi pos) n)
	(setq lst (append lst (list (nth (1+ n) sel) (nth n sel))) n (1+ n) pos (itoa n))
	(setq lst (append lst (list (nth n sel))))
      )
      (setq n (1+ n))
    )
    (setq sel lst)
  )

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Un coup vers le bas
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  (defun haut(/ n lst)
    (setq n 0)
    (while (nth n sel)
      (if (eq (1- (atoi pos)) n)
	(setq lst (append lst (list (nth (1+ n) sel) (nth n sel))) pos (itoa n) n (1+ n))
	(setq lst (append lst (list (nth n sel))))
      )
      (setq n (1+ n))
    )
    (setq sel lst)
  )

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Routine principale
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  (vla-startundomark (vla-get-activedocument (vlax-get-acad-object)))
  (if (setq f (findfile "latt.dcl"))
    (if (setq att (selection_chaine))
      (progn
	(setq dcl_id (load_dialog f) pos "0" sel (member (cadddr att) att))
	(new_dialog "latt" dcl_id)
	(set_tile "titre" "Trie des attributs")
	(affiche T)
	(mode_tile "att" 2)
	(action_tile "att"      "(setq pos $value)(affiche nil)")
	(action_tile "pos"      "(deplace $value)(affiche T)")
	(action_tile "haut"     "(haut)(affiche T)")
	(action_tile "bas"      "(bas)(affiche T)")
	(action_tile "cancel"   "(done_dialog 0)")
	(action_tile "accept"   "(done_dialog 1)")
	(setq r (start_dialog))
	(unload_dialog dcl_id)
	(if (eq r 1)
	  (progn
	    (setq att (append (list (car att) (cadr att) (caddr att)) sel))
	    (vlax-ldata-put "Patrick_35" (car att) (cdr att))
	    (effacer_les_reacteurs_objet)
	    (cond
	      ((eq (cadr att) "Croissant")
		(setq j 3 i (caddr att))
		(while (setq data (nth j att))
		  (if (vlax-read-enabled-p data)
		    (progn
		      (vla-put-textstring data i)
		      (setq i (incsuff i 1 T))
		    )
		  )
		  (setq j (1+ j))
		)
	      )
	      ((eq (cadr att) "Somme")
		(setq j 3)
		(while (setq data (nth j att))
		  (if (vlax-read-enabled-p data)
		    (progn
		      (if (eq j 3)
			(setq val1 0 val2 0)
			(setq val1 (read (vla-get-textstring (cadddr att))) val2 (read (vla-get-textstring (nth j att))))
		      )
		    (ecrire_texte_somme val1 val2 (cadddr att))
		    )
		  )
		  (setq j (1+ j))
		)
	      )
	    )
	    (refaire_les_reacteurs_objet)
	    (princ "\nTrie effectu.")
	  )
	)

      )
    )
    (princ "\nLe fichier LATT.DCL n'a pas t trouv.")
  )
  (vla-endundomark (vla-get-activedocument (vlax-get-acad-object)))
  (princ)
)


;-------------------------------------------------------------------------
; Attacher un attribut  une chaine somme ou croissant
;-------------------------------------------------------------------------

(defun c:ratt()
  (princ)
)

;-------------------------------------------------------------------------
; Effacer tous les Racteurs de Patrick_35
;-------------------------------------------------------------------------

(defun effacer_des_reacteurs(rea cde)
  (effacer_les_reacteurs_objet)
  (effacer_les_reacteurs_editor)
)

;-------------------------------------------------------------------------
; Effacer tous les Racteurs de Patrick_35
;-------------------------------------------------------------------------

(defun effacer_tous_reacteurs()
  (effacer_les_reacteurs_objet)
  (effacer_les_reacteurs_command)
)

;-------------------------------------------------------------------------
; Refaire tous les Racteurs de Patrick_35
;-------------------------------------------------------------------------

(defun refaire_tous_reacteurs()
  (refaire_les_reacteurs_objet)
  (vlr-deepclone-reactor nil (list (cons :vlr-begindeepclone   (function debut_command_copier))
				   (cons :vlr-abortdeepclone   (function arret_command_copier))
				   (cons :vlr-enddeepclone     (function fin_command_copier))))
  (vlr-editor-reactor    nil (list (cons :vlr-commandWillStart (function debut_command_attr))
				   (cons :vlr-commandcancelled (function arret_command_copier))
				   (cons :vlr-commandfailed    (function arret_command_copier))
				   (cons :vlr-commandEnded     (function fin_d_un_command))
				   (cons :vlr-beginclose       (function effacer_des_reacteurs))))
)

;-------------------------------------------------------------------------
; Lancement
;-------------------------------------------------------------------------

(vl-load-com)
(vl-load-reactors)
(acad-push-dbmod)
(verifier_base_Patrick_35)
(effacer_tous_reacteurs)
(refaire_tous_reacteurs)
(acad-pop-dbmod)
(princ "\n\tProgramme charg.\n\t---> LATT pour lier des attributs.\n\t---> EATT pour supprimer une chane d'attibuts.")
(princ "\n\t---> VATT pour visualiser une chane d'attributs.\n\t---> IATT pour incrmenter des attributs.")
(princ "\n\t---> TATT pour trier une chane d'attributs.\n\t---> MATT pour mmoriser une chane d'attributs.")
(princ)
